diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/dhcp6-server.h ns-3.45/src/internet-apps/model/dhcp6-server.h
--- ns-3.44/src/internet-apps/model/dhcp6-server.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/model/dhcp6-server.h	2025-06-01 20:34:45.315701200 -0700
@@ -0,0 +1,266 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#ifndef DHCP6_SERVER_H
+#define DHCP6_SERVER_H
+
+#include "dhcp6-duid.h"
+#include "dhcp6-header.h"
+
+#include "ns3/application.h"
+#include "ns3/ipv6-address.h"
+#include "ns3/net-device-container.h"
+#include "ns3/pair.h"
+#include "ns3/ptr.h"
+
+#include <map>
+
+namespace ns3
+{
+
+class Inet6SocketAddress;
+class Socket;
+class Packet;
+
+/**
+ * @ingroup dhcp6
+ *
+ * @class LeaseInfo
+ * @brief Includes information about available subnets and corresponding leases.
+ */
+class LeaseInfo
+{
+  public:
+    /**
+     * Constructor.
+     * @param addressPool Address pool
+     * @param prefix Prefix of the address pool
+     * @param minAddress Minimum address in the pool
+     * @param maxAddress Maximum address in the pool
+     */
+    LeaseInfo(Ipv6Address addressPool,
+              Ipv6Prefix prefix,
+              Ipv6Address minAddress,
+              Ipv6Address maxAddress);
+
+    friend class Dhcp6Server;
+
+  private:
+    /**
+     * @brief Get the address pool.
+     * @return The address pool
+     */
+    Ipv6Address GetAddressPool() const;
+
+    /**
+     * @brief Get the prefix of the address pool.
+     * @return The prefix of the address pool
+     */
+    Ipv6Prefix GetPrefix() const;
+
+    /**
+     * @brief Get the minimum address in the pool.
+     * @return The minimum address in the pool
+     */
+    Ipv6Address GetMinAddress() const;
+
+    /**
+     * @brief Get the maximum address in the pool.
+     * @return The maximum address in the pool
+     */
+    Ipv6Address GetMaxAddress() const;
+
+    /**
+     * @brief Get the number of addresses leased.
+     * @return The number of addresses leased
+     */
+    uint32_t GetNumAddresses() const;
+
+    /**
+     * @brief Expired Addresses (Section 6.2 of RFC 8415)
+     * Expired time / Ipv6Address
+     */
+    typedef std::multimap<Time, std::pair<Duid, Ipv6Address>> ExpiredAddresses;
+
+    /**
+     * @brief Leased Addresses
+     * Client DUID + Ipv6Address / Lease time
+     */
+    typedef std::unordered_multimap<Duid, std::pair<Ipv6Address, Time>, Duid::DuidHash>
+        LeasedAddresses;
+
+    /**
+     * @brief Declined Addresses
+     * Ipv6Address + Client DUID
+     */
+    typedef std::unordered_map<Ipv6Address, Duid, Ipv6AddressHash> DeclinedAddresses;
+
+    LeasedAddresses m_leasedAddresses;     //!< Leased addresses
+    ExpiredAddresses m_expiredAddresses;   //!< Expired addresses
+    DeclinedAddresses m_declinedAddresses; //!< Declined addresses
+    Ipv6Address m_maxOfferedAddress;       //!< Maximum address offered so far.
+
+    Ipv6Address m_addressPool; //!< Address pool
+    Ipv6Prefix m_prefix;       //!< Prefix of the address pool
+    Ipv6Address m_minAddress;  //!< Minimum address in the pool
+    Ipv6Address m_maxAddress;  //!< Maximum address in the pool
+    uint32_t m_numAddresses;   //!< Number of addresses leased.
+};
+
+/**
+ * @ingroup dhcp6
+ *
+ * @class Dhcp6Server
+ * @brief Implements the DHCPv6 server.
+ */
+class Dhcp6Server : public Application
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * @brief Default constructor.
+     */
+    Dhcp6Server();
+
+    /**
+     * @brief Set the list of net devices that the DHCPv6 server will use.
+     * @param netDevices The net devices that the server will listen on.
+     */
+    void SetDhcp6ServerNetDevice(NetDeviceContainer netDevices);
+
+    /**
+     * @brief Add a managed address pool.
+     * @param pool The address pool to be managed by the server.
+     * @param prefix The prefix of the address pool.
+     * @param minAddress The minimum address in the pool.
+     * @param maxAddress The maximum address in the pool.
+     */
+    void AddSubnet(Ipv6Address pool,
+                   Ipv6Prefix prefix,
+                   Ipv6Address minAddress,
+                   Ipv6Address maxAddress);
+
+  protected:
+    void DoDispose() override;
+
+  private:
+    void StartApplication() override;
+    void StopApplication() override;
+
+    /**
+     * @brief Handles incoming packets from the network
+     * @param socket Socket bound to port 547 of the DHCP server
+     */
+    void NetHandler(Ptr<Socket> socket);
+
+    /**
+     * @brief Sends DHCPv6 Advertise after receiving DHCPv6 Solicit.
+     * @param iDev incoming NetDevice
+     * @param header DHCPv6 header of the received message
+     * @param client Address of the DHCPv6 client
+     */
+    void ProcessSolicit(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress client);
+
+    /**
+     * @brief Sends DHCPv6 Advertise after receiving DHCPv6 Solicit.
+     * @param iDev incoming NetDevice
+     * @param header DHCPv6 header of the received message
+     * @param client Address of the DHCPv6 client
+     */
+    void SendAdvertise(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress client);
+
+    /**
+     * @brief Sends Reply after receiving Request
+     * @param iDev incoming NetDevice
+     * @param header DHCPv6 header of the received message
+     * @param client Address of the DHCP client
+     */
+    void SendReply(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress client);
+
+    /**
+     * @brief Sends Reply after receiving Request
+     * @param iDev incoming NetDevice
+     * @param header DHCPv6 header of the received message
+     * @param client Address of the DHCP client
+     */
+    void RenewRebindLeases(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress client);
+
+    /**
+     * @brief Sends Reply after receiving Request
+     * @param iDev incoming NetDevice
+     * @param header DHCPv6 header of the received message
+     * @param client Address of the DHCP client
+     */
+    void UpdateBindings(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress client);
+
+    /**
+     * @brief Modifies the remaining lease time of addresses
+     */
+    void TimerHandler();
+
+    /**
+     * @brief Callback for when an M flag is received.
+     * @param recvInterface The interface on which the M flag was received.
+     */
+    void ReceiveMflag(uint32_t recvInterface);
+
+    /**
+     * @brief Clean up stale lease info.
+     */
+    void CleanLeases();
+
+    Ptr<Socket> m_recvSocket;            //!< Socket bound to port 547.
+    Duid m_serverDuid;                   //!< Server DUID
+    std::vector<LeaseInfo> m_subnets;    //!< List of managed subnets.
+    Time m_leaseCleanup = Seconds(10.0); //!< Lease cleanup time
+    EventId m_leaseCleanupEvent;         //!< Event ID for lease cleanup
+
+    /// Map of NetDevice - Corresponding socket used to send packets.
+    std::unordered_map<uint32_t, Ptr<Socket>> m_sendSockets;
+
+    /// Store IA bindings. Map of DUID + IA Type / IAID
+    std::multimap<Duid, std::pair<Options::OptionType, uint32_t>> m_iaBindings;
+
+    /**
+     * @brief Default preferred lifetime for an address.
+     * According to ISC's Kea guide, the default preferred lifetime is 3000
+     * seconds.
+     */
+    Time m_prefLifetime;
+
+    /**
+     * @brief Default valid lifetime.
+     * According to ISC's Kea guide, the default valid lifetime is 4000 seconds.
+     */
+    Time m_validLifetime;
+
+    /**
+     * @brief The default renew timer.
+     * This defines the T1 timer. According to ISC's Kea guide, the default
+     * renew timer is 1000 seconds.
+     * Maximum value is REN_MAX_RT (RFC 8415, Section 7.6).
+     */
+    Time m_renew;
+
+    /**
+     * @brief The default rebind timer.
+     * This defines the T2 timer. According to ISC's Kea guide, the default
+     * rebind timer is 2000 seconds.
+     * Maximum value is REB_MAX_RT (RFC 8415, Section 7.6).
+     */
+    Time m_rebind;
+};
+} // namespace ns3
+
+#endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/dhcp-server.cc ns-3.45/src/internet-apps/model/dhcp-server.cc
--- ns-3.44/src/internet-apps/model/dhcp-server.cc	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/model/dhcp-server.cc	2025-06-01 20:34:45.314701300 -0700
@@ -319,8 +319,7 @@
                               InetSocketAddress(Ipv4Address("255.255.255.255"), from.GetPort()))) >=
             0)
         {
-            NS_LOG_INFO("DHCP OFFER"
-                        << " Offered Address: " << offeredAddress);
+            NS_LOG_INFO("DHCP OFFER Offered Address: " << offeredAddress);
         }
         else
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/radvd.cc ns-3.45/src/internet-apps/model/radvd.cc
--- ns-3.44/src/internet-apps/model/radvd.cc	2025-03-09 16:55:49.379371200 -0700
+++ ns-3.45/src/internet-apps/model/radvd.cc	2025-06-01 20:34:45.315701200 -0700
@@ -77,13 +77,19 @@
 {
     NS_LOG_FUNCTION(this);
 
-    m_recvSocket->Close();
-    m_recvSocket = nullptr;
+    if (m_recvSocket)
+    {
+        m_recvSocket->Close();
+        m_recvSocket = nullptr;
+    }
 
     for (auto it = m_sendSockets.begin(); it != m_sendSockets.end(); ++it)
     {
-        it->second->Close();
-        it->second = nullptr;
+        if (it->second)
+        {
+            it->second->Close();
+            it->second = nullptr;
+        }
     }
 
     Application::DoDispose();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/test/dhcp6-test.cc ns-3.45/src/internet-apps/test/dhcp6-test.cc
--- ns-3.44/src/internet-apps/test/dhcp6-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/test/dhcp6-test.cc	2025-06-01 20:34:45.315701200 -0700
@@ -0,0 +1,200 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#include "ns3/applications-module.h"
+#include "ns3/core-module.h"
+#include "ns3/csma-module.h"
+#include "ns3/data-rate.h"
+#include "ns3/dhcp6-header.h"
+#include "ns3/dhcp6-helper.h"
+#include "ns3/header-serialization-test.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv6-address-helper.h"
+#include "ns3/log.h"
+#include "ns3/mobility-module.h"
+#include "ns3/network-module.h"
+#include "ns3/ping-helper.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/simple-net-device-helper.h"
+#include "ns3/simple-net-device.h"
+#include "ns3/simulator.h"
+#include "ns3/ssid.h"
+#include "ns3/test.h"
+#include "ns3/trace-helper.h"
+#include "ns3/wifi-helper.h"
+#include "ns3/yans-wifi-helper.h"
+
+using namespace ns3;
+
+/**
+ * @ingroup dhcp6
+ * @defgroup dhcp6-test DHCPv6 module tests
+ */
+
+/**
+ * @ingroup dhcp6-test
+ * @ingroup tests
+ *
+ * @brief DHCPv6 header tests
+ */
+class Dhcp6TestCase : public TestCase
+{
+  public:
+    Dhcp6TestCase();
+    ~Dhcp6TestCase() override;
+
+    /**
+     * Triggered by an address lease on a client.
+     * @param context The test name.
+     * @param newAddress The leased address.
+     */
+    void LeaseObtained(std::string context, const Ipv6Address& newAddress);
+
+  private:
+    void DoRun() override;
+    Ipv6Address m_leasedAddress[2]; //!< Address given to the nodes
+};
+
+Dhcp6TestCase::Dhcp6TestCase()
+    : TestCase("Dhcp6 test case ")
+{
+}
+
+Dhcp6TestCase::~Dhcp6TestCase()
+{
+}
+
+void
+Dhcp6TestCase::LeaseObtained(std::string context, const Ipv6Address& newAddress)
+{
+    uint8_t numericalContext = std::stoi(context, nullptr, 10);
+
+    if (numericalContext >= 0 && numericalContext < std::size(m_leasedAddress))
+    {
+        m_leasedAddress[numericalContext] = newAddress;
+    }
+}
+
+void
+Dhcp6TestCase::DoRun()
+{
+    NodeContainer nonRouterNodes;
+    nonRouterNodes.Create(3);
+    Ptr<Node> router = CreateObject<Node>();
+    NodeContainer all(nonRouterNodes, router);
+
+    SimpleNetDeviceHelper simpleNetDevice;
+    simpleNetDevice.SetChannelAttribute("Delay", TimeValue(MilliSeconds(2)));
+    simpleNetDevice.SetDeviceAttribute("DataRate", DataRateValue(DataRate("5Mbps")));
+    NetDeviceContainer devices = simpleNetDevice.Install(all); // all nodes
+
+    InternetStackHelper internetv6;
+    internetv6.Install(all);
+
+    Ipv6AddressHelper ipv6;
+    ipv6.SetBase(Ipv6Address("2001:cafe::"), Ipv6Prefix(64));
+    NetDeviceContainer nonRouterDevices;
+    nonRouterDevices.Add(devices.Get(0)); // The server node, S0.
+    nonRouterDevices.Add(devices.Get(1)); // The first client node, N0.
+    nonRouterDevices.Add(devices.Get(2)); // The second client node, N1.
+    Ipv6InterfaceContainer i = ipv6.AssignWithoutAddress(nonRouterDevices);
+
+    NetDeviceContainer routerDevice;
+    routerDevice.Add(devices.Get(3)); // CSMA interface of the node R0.
+    Ipv6InterfaceContainer r1 = ipv6.Assign(routerDevice);
+    r1.SetForwarding(0, true);
+
+    RadvdHelper radvdHelper;
+
+    /* Set up unsolicited RAs */
+    radvdHelper.AddAnnouncedPrefix(r1.GetInterfaceIndex(0), Ipv6Address("2001:cafe::1"), 64);
+    radvdHelper.GetRadvdInterface(r1.GetInterfaceIndex(0))->SetManagedFlag(true);
+
+    Dhcp6Helper dhcp6Helper;
+
+    dhcp6Helper.SetServerAttribute("RenewTime", StringValue("10s"));
+    dhcp6Helper.SetServerAttribute("RebindTime", StringValue("16s"));
+    dhcp6Helper.SetServerAttribute("PreferredLifetime", StringValue("18s"));
+    dhcp6Helper.SetServerAttribute("ValidLifetime", StringValue("20s"));
+
+    // DHCPv6 clients
+    NodeContainer nodes = NodeContainer(nonRouterNodes.Get(1), nonRouterNodes.Get(2));
+    ApplicationContainer dhcpClients = dhcp6Helper.InstallDhcp6Client(nodes);
+    dhcpClients.Start(Seconds(1.0));
+    dhcpClients.Stop(Seconds(20.0));
+
+    // DHCPv6 server
+    NetDeviceContainer serverNetDevices;
+    serverNetDevices.Add(nonRouterDevices.Get(0));
+    ApplicationContainer dhcpServerApp = dhcp6Helper.InstallDhcp6Server(serverNetDevices);
+
+    Ptr<Dhcp6Server> server = DynamicCast<Dhcp6Server>(dhcpServerApp.Get(0));
+    server->AddSubnet(Ipv6Address("2001:cafe::"),
+                      Ipv6Prefix(64),
+                      Ipv6Address("2001:cafe::42:1"),
+                      Ipv6Address("2001:cafe::42:ffff"));
+
+    dhcpServerApp.Start(Seconds(0.0));
+    dhcpServerApp.Stop(Seconds(20.0));
+
+    ApplicationContainer radvdApps = radvdHelper.Install(router);
+    radvdApps.Start(Seconds(1.0));
+    radvdApps.Stop(Seconds(20.0));
+
+    dhcpClients.Get(0)->TraceConnect("NewLease",
+                                     "0",
+                                     MakeCallback(&Dhcp6TestCase::LeaseObtained, this));
+    dhcpClients.Get(1)->TraceConnect("NewLease",
+                                     "1",
+                                     MakeCallback(&Dhcp6TestCase::LeaseObtained, this));
+
+    Simulator::Stop(Seconds(21.0));
+    Simulator::Run();
+
+    // Validate that the client nodes have three addresses on each interface -
+    // link-local, autoconfigured, and leased from DHCPv6 server.
+    Ptr<Ipv6> ipv6_client1 = nonRouterNodes.Get(1)->GetObject<Ipv6>();
+    Ptr<Ipv6L3Protocol> l3_client1 = ipv6_client1->GetObject<Ipv6L3Protocol>();
+    int32_t ifIndex_client1 = ipv6_client1->GetInterfaceForDevice(nonRouterDevices.Get(1));
+
+    NS_TEST_ASSERT_MSG_EQ(l3_client1->GetNAddresses(ifIndex_client1),
+                          3,
+                          "Incorrect number of addresses.");
+
+    Ptr<Ipv6> ipv6_client2 = nonRouterNodes.Get(2)->GetObject<Ipv6>();
+    Ptr<Ipv6L3Protocol> l3_client2 = ipv6_client2->GetObject<Ipv6L3Protocol>();
+    int32_t ifIndex_client2 = ipv6_client2->GetInterfaceForDevice(nonRouterDevices.Get(2));
+    NS_TEST_ASSERT_MSG_EQ(l3_client2->GetNAddresses(ifIndex_client2),
+                          3,
+                          "Incorrect number of addresses.");
+
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup dhcp6-test
+ * @ingroup tests
+ *
+ * @brief DHCPv6 TestSuite
+ */
+class Dhcp6TestSuite : public TestSuite
+{
+  public:
+    Dhcp6TestSuite();
+};
+
+Dhcp6TestSuite::Dhcp6TestSuite()
+    : TestSuite("dhcp6", Type::UNIT)
+{
+    AddTestCase(new Dhcp6TestCase, TestCase::Duration::QUICK);
+}
+
+static Dhcp6TestSuite dhcp6TestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lr-wpan/examples/CMakeLists.txt ns-3.45/src/lr-wpan/examples/CMakeLists.txt
--- ns-3.44/src/lr-wpan/examples/CMakeLists.txt	2025-03-09 16:55:49.419371100 -0700
+++ ns-3.45/src/lr-wpan/examples/CMakeLists.txt	2025-06-01 20:34:45.337701300 -0700
@@ -1,6 +1,6 @@
 set(base_examples
     lr-wpan-data
-    lr-wpan-mlme
+    lr-wpan-beacon-mode
     lr-wpan-packet-print
     lr-wpan-phy-test
     lr-wpan-ed-scan
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lr-wpan/examples/lr-wpan-beacon-mode.cc ns-3.45/src/lr-wpan/examples/lr-wpan-beacon-mode.cc
--- ns-3.44/src/lr-wpan/examples/lr-wpan-beacon-mode.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/lr-wpan/examples/lr-wpan-beacon-mode.cc	2025-06-01 20:34:45.337701300 -0700
@@ -0,0 +1,198 @@
+/*
+ * Copyright (c) 2019 Ritsumeikan University, Shiga, Japan.
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
+ */
+
+/*
+ *   Coordinator              End Device
+ *       N0   <----------------  N1
+ *      (dev0)                 (dev1)
+ *
+ * This example demonstrate the usage of the MAC primitives involved in
+ * direct transmissions for the beacon enabled mode of IEEE 802.15.4-2011.
+ * A single packet is sent from an end device to the coordinator during the CAP
+ * of the first incoming superframe.
+ *
+ * This example do not demonstrate a full protocol stack usage.
+ * For full protocol stack usage refer to 6lowpan examples.
+ *
+ */
+
+#include "ns3/constant-position-mobility-model.h"
+#include "ns3/core-module.h"
+#include "ns3/log.h"
+#include "ns3/lr-wpan-module.h"
+#include "ns3/packet.h"
+#include "ns3/propagation-delay-model.h"
+#include "ns3/propagation-loss-model.h"
+#include "ns3/simulator.h"
+#include "ns3/single-model-spectrum-channel.h"
+
+#include <iostream>
+
+using namespace ns3;
+using namespace ns3::lrwpan;
+
+void
+BeaconIndication(MlmeBeaconNotifyIndicationParams params)
+{
+    NS_LOG_UNCOND(Simulator::Now().GetSeconds() << " secs | Received BEACON packet of size ");
+}
+
+void
+DataIndication(McpsDataIndicationParams params, Ptr<Packet> p)
+{
+    NS_LOG_UNCOND(Simulator::Now().GetSeconds()
+                  << " secs | Received DATA packet of size " << p->GetSize());
+}
+
+void
+TransEndIndication(McpsDataConfirmParams params)
+{
+    // In the case of transmissions with the Ack flag activated, the transaction is only
+    // successful if the Ack was received.
+    if (params.m_status == MacStatus::SUCCESS)
+    {
+        NS_LOG_UNCOND(Simulator::Now().GetSeconds() << " secs | Transmission successfully sent");
+    }
+}
+
+void
+DataIndicationCoordinator(McpsDataIndicationParams params, Ptr<Packet> p)
+{
+    NS_LOG_UNCOND(Simulator::Now().GetSeconds()
+                  << "s Coordinator Received DATA packet (size " << p->GetSize() << " bytes)");
+}
+
+void
+StartConfirm(MlmeStartConfirmParams params)
+{
+    if (params.m_status == MacStatus::SUCCESS)
+    {
+        NS_LOG_UNCOND(Simulator::Now().GetSeconds() << "Beacon status SUCCESSFUL");
+    }
+}
+
+int
+main(int argc, char* argv[])
+{
+    LogComponentEnableAll(LOG_PREFIX_TIME);
+    LogComponentEnableAll(LOG_PREFIX_FUNC);
+    LogComponentEnable("LrWpanMac", LOG_LEVEL_INFO);
+    LogComponentEnable("LrWpanCsmaCa", LOG_LEVEL_INFO);
+
+    LrWpanHelper lrWpanHelper;
+
+    // Create 2 nodes, and a NetDevice for each one
+
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    // Use LrWpanHelper to create devices and assign them to nodes
+    lrWpanHelper.SetPropagationDelayModel("ns3::ConstantSpeedPropagationDelayModel");
+    lrWpanHelper.AddPropagationLossModel("ns3::LogDistancePropagationLossModel");
+    NetDeviceContainer devices = lrWpanHelper.Install(nodes);
+    Ptr<LrWpanNetDevice> dev0 = devices.Get(0)->GetObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> dev1 = devices.Get(1)->GetObject<LrWpanNetDevice>();
+
+    dev0->SetAddress(Mac16Address("00:01"));
+    dev1->SetAddress(Mac16Address("00:02"));
+
+    ///////////////// Mobility   ///////////////////////
+    Ptr<ConstantPositionMobilityModel> sender0Mobility =
+        CreateObject<ConstantPositionMobilityModel>();
+    sender0Mobility->SetPosition(Vector(0, 0, 0));
+    dev0->GetPhy()->SetMobility(sender0Mobility);
+    Ptr<ConstantPositionMobilityModel> sender1Mobility =
+        CreateObject<ConstantPositionMobilityModel>();
+
+    sender1Mobility->SetPosition(Vector(0, 10, 0)); // 10 m distance
+    dev1->GetPhy()->SetMobility(sender1Mobility);
+
+    /////// MAC layer Callbacks hooks/////////////
+
+    MlmeStartConfirmCallback cb0;
+    cb0 = MakeCallback(&StartConfirm);
+    dev0->GetMac()->SetMlmeStartConfirmCallback(cb0);
+
+    McpsDataConfirmCallback cb1;
+    cb1 = MakeCallback(&TransEndIndication);
+    dev1->GetMac()->SetMcpsDataConfirmCallback(cb1);
+
+    MlmeBeaconNotifyIndicationCallback cb3;
+    cb3 = MakeCallback(&BeaconIndication);
+    dev1->GetMac()->SetMlmeBeaconNotifyIndicationCallback(cb3);
+
+    McpsDataIndicationCallback cb4;
+    cb4 = MakeCallback(&DataIndication);
+    dev1->GetMac()->SetMcpsDataIndicationCallback(cb4);
+
+    McpsDataIndicationCallback cb5;
+    cb5 = MakeCallback(&DataIndicationCoordinator);
+    dev0->GetMac()->SetMcpsDataIndicationCallback(cb5);
+
+    //////////// Manual device association ////////////////////
+    // Note: We manually associate the devices to a PAN coordinator
+    //       (i.e. bootstrap is not used);
+    //       The PAN COORDINATOR does not need to associate or set its
+    //       PAN Id or its own coordinator id, these are set
+    //       by the MLME-start.request primitive when used.
+
+    dev1->GetMac()->SetPanId(5);
+    dev1->GetMac()->SetAssociatedCoor(Mac16Address("00:01"));
+
+    ///////////////////// Start transmitting beacons from coordinator ////////////////////////
+
+    MlmeStartRequestParams params;
+    params.m_panCoor = true;
+    params.m_PanId = 5;
+    params.m_bcnOrd = 14;
+    params.m_sfrmOrd = 6;
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(2),
+                                   &LrWpanMac::MlmeStartRequest,
+                                   dev0->GetMac(),
+                                   params);
+
+    ///////////////////// Transmission of data Packets from end device //////////////////////
+
+    Ptr<Packet> p1 = Create<Packet>(5);
+    McpsDataRequestParams params2;
+    params2.m_dstPanId = 5;
+    params2.m_srcAddrMode = SHORT_ADDR;
+    params2.m_dstAddrMode = SHORT_ADDR;
+    params2.m_dstAddr = Mac16Address("00:01");
+    params2.m_msduHandle = 0;
+    // params2.m_txOptions = TX_OPTION_ACK;  // Enable direct transmission with Ack
+
+    /////////////////////////////////////////////////////////////////////////////////////
+    // Examples of time parameters for transmissions in the first incoming superframe. //
+    /////////////////////////////////////////////////////////////////////////////////////
+
+    // 2.981 sec      No time to finish CCA in CAP, the transmission at this time will cause
+    //                the packet to be deferred to the next superframe.
+
+    // 2.982 sec      No time to finish random backoff delay in CAP, the  transmission at this
+    //                time will cause the packet to be deferred to the next superframe.
+
+    // 2.93 sec       Enough time, the packet can be transmitted within the CAP of the first
+    // superframe
+
+    // MCPS-DATA.request Beacon enabled Direct Transmission (dev1)
+    // Frame transmission from End Device to Coordinator (Direct transmission)
+    Simulator::ScheduleWithContext(1,
+                                   Seconds(2.93),
+                                   &LrWpanMac::McpsDataRequest,
+                                   dev1->GetMac(),
+                                   params2,
+                                   p1);
+
+    Simulator::Stop(Seconds(600));
+    Simulator::Run();
+
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lr-wpan/examples/lr-wpan-data.cc ns-3.45/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.44/src/lr-wpan/examples/lr-wpan-data.cc	2025-03-09 16:55:49.419371100 -0700
+++ ns-3.45/src/lr-wpan/examples/lr-wpan-data.cc	2025-06-01 20:34:45.337701300 -0700
@@ -46,7 +46,7 @@
 static void
 DataConfirm(McpsDataConfirmParams params)
 {
-    NS_LOG_UNCOND("LrWpanMcpsDataConfirmStatus = " << params.m_status);
+    NS_LOG_UNCOND("LrWpanMcpsDataConfirmStatus = " << static_cast<uint16_t>(params.m_status));
 }
 
 /**
@@ -126,18 +126,23 @@
     //    Ptr<LrWpanNetDevice> dev0 = devices.Get(0)->GetObject<LrWpanNetDevice>();
     //    Ptr<LrWpanNetDevice> dev1 = devices.Get(1)->GetObject<LrWpanNetDevice>();
 
-    // Set 16-bit short addresses if extended is false, otherwise use 64-bit extended addresses
+    // Set 16-bit and 64-bit MAC addresses.
+    // Note: Extended addresses must ALWAYS be present. If the devices are using the extended
+    // address mode, short addresses should use the short address FF:FE. A short address of FF:FF
+    // indicates that the devices is not associated to any device.
     if (!extended)
     {
-        dev0->SetAddress(Mac16Address("00:01"));
-        dev1->SetAddress(Mac16Address("00:02"));
+        dev0->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
+        dev1->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+        dev0->GetMac()->SetShortAddress(Mac16Address("00:01"));
+        dev1->GetMac()->SetShortAddress(Mac16Address("00:02"));
     }
     else
     {
-        Ptr<LrWpanMac> mac0 = dev0->GetMac();
-        Ptr<LrWpanMac> mac1 = dev1->GetMac();
-        mac0->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
-        mac1->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+        dev0->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
+        dev1->GetMac()->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+        dev0->GetMac()->SetShortAddress(Mac16Address("FF:FE"));
+        dev1->GetMac()->SetShortAddress(Mac16Address("FF:FE"));
     }
 
     // Trace state changes in the phy
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lr-wpan/model/lr-wpan-mac-header.h ns-3.45/src/lr-wpan/model/lr-wpan-mac-header.h
--- ns-3.44/src/lr-wpan/model/lr-wpan-mac-header.h	2025-03-09 16:55:49.419371100 -0700
+++ ns-3.45/src/lr-wpan/model/lr-wpan-mac-header.h	2025-06-01 20:34:45.339701200 -0700
@@ -431,10 +431,11 @@
 
     uint8_t m_secctrlReserved; //!< Auxiliary security header - Security Control field - Bit 5-7
 
+    /// Auxiliary security header
     union {
         uint32_t m_auxKeyIdKeySrc32; //!< Auxiliary security header - Key Source (4 Octets)
         uint64_t m_auxKeyIdKeySrc64; //!< Auxiliary security header - Key Source (8 Octets)
-    };                               //!< Auxiliary security header
+    };
 
     uint8_t m_auxKeyIdKeyIndex; //!< Auxiliary security header - Key Index (1 Octet)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/examples/lena-dual-stripe.cc ns-3.45/src/lte/examples/lena-dual-stripe.cc
--- ns-3.44/src/lte/examples/lena-dual-stripe.cc	2025-03-09 16:55:49.471371400 -0700
+++ ns-3.45/src/lte/examples/lena-dual-stripe.cc	2025-06-01 20:34:45.367701300 -0700
@@ -896,7 +896,7 @@
                             InetSocketAddress(Ipv4Address::GetAny(), ulPort));
                         serverApps.Add(ulPacketSinkHelper.Install(remoteHost));
                     }
-                } // end if (useUdp)
+                }
 
                 Ptr<EpcTft> tft = Create<EpcTft>();
                 if (epcDl)
@@ -922,8 +922,7 @@
                 Time startTime = Seconds(startTimeSeconds->GetValue());
                 serverApps.Start(startTime);
                 clientApps.Start(startTime);
-
-            } // end for b
+            }
         }
     }
     else // (epc == false)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/examples/lena-radio-link-failure.cc ns-3.45/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.44/src/lte/examples/lena-radio-link-failure.cc	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/examples/lena-radio-link-failure.cc	2025-06-01 20:34:45.368701500 -0700
@@ -556,7 +556,7 @@
             dlClientApps.Start(Seconds(0.27));
             ulServerApps.Start(Seconds(0.27));
             ulClientApps.Start(Seconds(0.27));
-        } // end for b
+        }
     }
     NS_LOG_INFO("Enable Lte traces and connect custom trace sinks");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/examples/lena-x2-handover.cc ns-3.45/src/lte/examples/lena-x2-handover.cc
--- ns-3.44/src/lte/examples/lena-x2-handover.cc	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/examples/lena-x2-handover.cc	2025-06-01 20:34:45.368701500 -0700
@@ -323,8 +323,7 @@
             serverApps.Start(startTime);
             clientApps.Start(startTime);
             clientApps.Stop(simTime);
-
-        } // end for b
+        }
     }
 
     // Add X2 interface
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/examples/lena-x2-handover-measures.cc ns-3.45/src/lte/examples/lena-x2-handover-measures.cc
--- ns-3.44/src/lte/examples/lena-x2-handover-measures.cc	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/examples/lena-x2-handover-measures.cc	2025-06-01 20:34:45.368701500 -0700
@@ -276,8 +276,7 @@
             Time startTime = Seconds(startTimeSeconds->GetValue());
             serverApps.Start(startTime);
             clientApps.Start(startTime);
-
-        } // end for b
+        }
     }
 
     // Add X2 interface
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/helper/cc-helper.h ns-3.45/src/lte/helper/cc-helper.h
--- ns-3.44/src/lte/helper/cc-helper.h	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/helper/cc-helper.h	2025-06-01 20:34:45.368701500 -0700
@@ -187,8 +187,7 @@
     uint16_t m_dlBandwidth;               ///< Downlink Bandwidth
     uint16_t m_ulBandwidth;               ///< Uplink Bandwidth
     uint16_t m_numberOfComponentCarriers; ///< Number of component carriers
-
-}; // end of `class LteHelper`
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/helper/emu-epc-helper.cc ns-3.45/src/lte/helper/emu-epc-helper.cc
--- ns-3.44/src/lte/helper/emu-epc-helper.cc	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/helper/emu-epc-helper.cc	2025-06-01 20:34:45.368701500 -0700
@@ -89,12 +89,6 @@
     return tid;
 }
 
-TypeId
-EmuEpcHelper::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
 void
 EmuEpcHelper::DoDispose()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/lte/helper/emu-epc-helper.h ns-3.45/src/lte/helper/emu-epc-helper.h
--- ns-3.44/src/lte/helper/emu-epc-helper.h	2025-03-09 16:55:49.475371400 -0700
+++ ns-3.45/src/lte/helper/emu-epc-helper.h	2025-06-01 20:34:45.368701500 -0700
@@ -47,7 +47,6 @@
      * @return The object TypeId.
      */
     static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
     void DoDispose() override;
 
     // inherited from EpcHelper
